#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

void main(void) {
  unsigned long a,b;
  print("Demo program for speed measurement\n");


  TRIG_INT_ENABLE(); // enable trigger event
  ENC_WRITE_CNT(0);  // reset counter
  ENC_WRITE_RELOAD(1024); // set comparator value to 1024 pulse which is one turnaround
  ENC_WAIT_N_TRIG(); // enable n-mode: trigger pulse will be unlocked with each n-pulse 
                     // and counter will be reset with each n-pulse
  while(!kbhit()) {
	print("%d\n", ENC_READ_CNT());  // show counter value

	disints();
	a=getvar(MSEC) + 1000*getvar(SEC); // get milliseconds before event
	enaints();

	if( wait(TRIG_READY, 3000) > 0) // wait for trigger event which occurs when counter
	                                // reachs comparator value of 1024
									// timeout for wait() is 3 seconds
	{
	  disints();                     
	  b=getvar(MSEC) + 1000*getvar(SEC); // get milliseconds after event
	  enaints();

	  print("* 1 turn in %d ms (%f rpm) *\n",b-a,(float)60000/(float)(b-a));
	}
	else
	  print("*timeout* \n");

  }

}
